#!/usr/bin/perl 

# This package allows other perl scripts to access the resource gateway 
# configuration. 

package gw_shared;

require         Exporter;
@ISA            =qw(Exporter);
@EXPORT         =qw(%gw_config);
@EXPORT_OK      =qw(%gw_config);

use lib "$ENV{PWD}/";
use lib "$ENV{NORDUGRID_LOCATION}/libexec";
use lib "/opt/nordugrid/libexec";
#use warnings;

# Defaults
#$gw_config{gateway_enabled} = 0;
#$gw_config{$gateway_conf} = "";
#$gw_config{$gateway_lib} = "";
#$gw_config{$remote_query} = "";
#$gw_config{$submit_job} = "";
#$gw_config{$cancel_job} = "";
#$gw_config{$upload_job} = "";
#$gw_config{$download_job} = "";

#print("gw_config before parsing: $gw_config{gateway_enabled} ... \n");

sub parse_conf() {
	# parse configuration file and fill in values in gw_config
	my $conf = $_[0];

	unless(open(CONF, "<$conf")) {
		print("WARNING: failed to open $conf for reading!\n");
		return "";	
	}

	my @lines = <CONF>;
	foreach $line(@lines) {
		chop($line);

		# skip blank lines and pure comments
		if ($line =~ /^$/) {
			next;
		}
		if ($line =~ /^\s*#/) {
			next;
		}
		
		#print("read line: $line\n");
		if ($line =~ /^\s*([^=\s]+)\s*=\s*([^\s#]+)\s*(#.*)?$/) {
			$option=$1;
			$value=$2;
			#chop($value);
			#print("parse_conf: found $option=$value ($1 ; $2)\n");
			$gw_config{$option} = $value;
		}
     	}

	unless(close(CONF)) {
		print("WARNING: failed to close $conf - ignoring!\n");
	}
	
}

if($ENV{NORDUGRID_LOCATION}) {
	$gateway_inc = "$ENV{NORDUGRID_LOCATION}";
} else {
	$gateway_inc = "/opt/nordugrid";
}

$gateway_inc = "$gateway_inc/etc/remote-lrms.conf";
#print("gateway_inc: $gateway_inc\n");

&parse_conf("$gateway_inc");

#print("gw_config:\n");
#foreach $key(keys % gw_config) {
#	print("\t$key\t:\t$gw_config{$key}\n");
#}

if($gw_config{gateway_lib}) {
	$gw_config{remote_query} = "$gw_config{gateway_lib}/query_resource.py";
	$gw_config{submit_job} = "$gw_config{gateway_lib}/submit_job.py";
	$gw_config{cancel_job} = "$gw_config{gateway_lib}/cancel_job.py";
	$gw_config{upload_job} = "$gw_config{gateway_lib}/upload_job.py";
	$gw_config{download_job} = "$gw_config{gateway_lib}/download_job.py";
}

1;
